// Please use this file to pull in any additional javascript files needed by your application

// Adding computed value for rounding the version number
document.addEventListener('gc-databind-ready', function () {
    /*
     *   function gc.databind.registry.bind(targetBinding, modelBinding, getter, [setter]);
     */
    gc.databind.registry.bind('widget.firmwareVersion.label', 'pm.G_FIRMWARE_VERSION',
        function (value) {
            return (+value).toFixed(1);
        });

    gc.databind.registry.bind('widget.ti_widget_dial1.disabled', "pm.G_CLK_MODE", function (val) {
        if (val === 0) {
            return false;
        } else {
            return true;
        }
    }, function(val){
        if(val === false){
            return 0;
        }else{
            return 1;
        }
    });

    gc.databind.registry.bind('widget.paper_toggle_button6.disabled', "pm.G_ENBL_START_STOP || pm.G_MOTOR_CMD_ACTIVE2 || pm.G_MOTOR_CMD_ACTIVE3");
    gc.databind.registry.bind('widget.paper_toggle_button5.disabled', "pm.G_ENBL_MOVE_STEPS || pm.G_MOTOR_CMD_ACTIVE1 || (!pm.G_MOTOR_CMD_ACTIVE2 && !pm.G_IDLE) || pm.G_MOTOR_CMD_ACTIVE3");
    gc.databind.registry.bind('widget.paper_toggle_button.disabled', "pm.G_ENBL_RECIPROCATION_BUTTON || pm.G_MOTOR_CMD_ACTIVE1 || (!pm.G_MOTOR_CMD_ACTIVE3 && !pm.G_IDLE) || pm.G_MOTOR_CMD_ACTIVE2");
});
var initComplete = false;

function writeDeviceValue(symbol, value){
    gc.target.access.writeValue(symbol, value);
}

var init = function(){
    let templateObj = document.querySelector('#template_obj');

    if(templateObj){
        templateObj.addEventListener('dom-change', function () {
            if (initComplete) return;
            this.async(function () {
                initComplete = true;
               
                //var ds = document.querySelector("#pm").$.ds;
        
                templateObj.$.ti_widget_button.addEventListener("click", function () {
                    gc.target.access.writeValue('G_BRAKE', 1);
                })
                templateObj.$.ti_widget_button1.addEventListener("click", function () {
                    gc.target.access.writeValue('G_BRAKE', 1);
                })
                templateObj.$.ti_widget_button2.addEventListener("click", function () {
                    gc.target.access.writeValue('G_BRAKE', 1);
                })
                templateObj.$.ti_widget_button3.addEventListener("click", function () {
                    gc.target.access.writeValue('G_BURN_OTP', 1);
                })
                templateObj.$.ti_widget_button4.addEventListener("click", function () {
                    gc.target.access.writeValue('G_WRITE_BUT', 1);
                })
                templateObj.$.ti_widget_button5.addEventListener("click", function () {
                    gc.target.access.writeValue('G_READ_BUT', 1);
                })
                templateObj.$.ti_widget_button6.addEventListener("click", function () {
                    gc.target.access.writeValue('G_WRITE_ALL', 1);
                })
                templateObj.$.ti_widget_button7.addEventListener("click", function () {
                    gc.target.access.writeValue('G_READ_ALL', 1);
                })
            }, 1);
        });
    }
}

templateObj = document.querySelector('#template_obj');
if (templateObj) {
  init();
} else {
  document.addEventListener('DOMContentLoaded', init);
}
